      program main
c
c  convert between binary and ascii adiabatic oscillation modes.
c
c  if icmode = 1 modes are read from full set of eigenfunctions, and
c  if icmode = 2 modes are read from restricted set.
c
c
c  Double precision version
c  ++++++++++++++++++++++++
c
c  Dated 2/6/14
c
      implicit double precision (a-h, o-z)
      character*80 fin, fout
      dimension xin(100000),yin(6,100000),cs(50), ics(24)
c
c  common defining standard input and output
c
      common/cstdio/ istdin, istdou, istdpr, istder
      equivalence(cs(39), ics(1))
c
      if(istdpr.gt.0) then
        write(istdpr,*) 
     *    'Enter 1 for transformation from binary to ASCII'
        write(istdpr,*) 
     *    '      2 for transformation from ASCII to binary'
      end if
      read(5,*) icase
c
      if(istdpr.gt.0) write(istdpr,*) 'Enter input file name'
      read(5,'(a)',end=90,err=90) fin
      if(istdpr.gt.0) write(istdpr,*) 'Enter output file name'
      read(5,'(a)',end=90,err=90) fout
      if(istdpr.gt.0) 
     *  write(istdpr,*) 'Enter 1 for full set, 2 for restricted set'
      read(5,*) icmode
c
      if(icase.eq.1) then
        open(2,file=fin,status='old',form='unformatted')
        open(3,file=fout,status='unknown')
      else
        open(2,file=fin,status='old')
        open(3,file=fout,status='unknown',form='unformatted')
      end if
      if(istdpr.gt.0) write(istdpr,'(/2a)') ' Transform file ',
     *  fin(1:length(fin))
c
      nm=0
c
c  test for case of reading
c
      if(icmode.eq.2) then
c
c  read x
c
        if(icase.eq.1) then
          read(2,end=90) nnin,(xin(n),n=1,nnin)
          write(3,'(i10/(1p5e16.8))') nnin,(xin(n),n=1,nnin)
        else
          read(2,'(i10/(1p5e16.8))',end=90) nnin,(xin(n),n=1,nnin)
          write(3) nnin,(xin(n),n=1,nnin)
        end if
c
      end if
c
c
   10 continue
c
c  test for case
c
      if(icmode.ne.2) then
        if(icase.eq.1) then
          read(2,end=90) cs,nnin,(xin(n),(yin(i,n),i=1,6),n=1,nnin)
c..          nordg=ics(10)
c..          write(istdpr,*) '#D# nordg =',nordg
          write(3,'(1p5e16.8)') (cs(i),i=1,38)
          write(3,'(8i10)') (ics(i),i=1,24)
          write(3,'(i10/(1p5e16.8))') 
     *      nnin,(xin(n),(yin(i,n),i=1,6),n=1,nnin)
        else
          read(2,'(1p5e16.8)',end=90) (cs(i),i=1,38)
          read(2,'(8i10)',end=90) (ics(i),i=1,24)
          read(2,'(i10/(1p5e16.8))',end=90) 
     *      nnin,(xin(n),(yin(i,n),i=1,6),n=1,nnin)
          write(3) cs,nnin,(xin(n),(yin(i,n),i=1,6),n=1,nnin)
        end if
      else
        if(icase.eq.1) then
          read(2,end=90) cs,((yin(i,n),i=1,2),n=1,nnin)
          write(3,'(1p5e16.8)') (cs(i),i=1,38)
          write(3,'(8i10)') (ics(i),i=1,24)
          write(3,'(1p5e16.8)') ((yin(i,n),i=1,2),n=1,nnin)
        else
          read(2,'(1p5e16.8)',end=90) (cs(i),i=1,38)
          read(2,'(8i10)') (ics(i),i=1,24)
          read(2,'(1p5e16.8)') ((yin(i,n),i=1,2),n=1,nnin)
          write(3) cs,((yin(i,n),i=1,2),n=1,nnin)
        end if
      end if
c
      l=cs(18)+0.5
      nord=cs(19)
c
c  set flag for inclusion of rotation
c
      icase_read=ics(5)
      irotsl=mod(icase_read/100,10)
      if(irotsl.eq.1) then
	em=cs(38)
	m=nint(em)
        if(nm.eq.0.and.istdpr.gt.0) write(istdpr,130) fin(1:length(fin))
      else
        if(nm.eq.0.and.istdpr.gt.0) write(istdpr,135) fin(1:length(fin))
      end if
c
      nm=nm+1
c
      if(istdpr.gt.0) then
        frq=1000*cs(27)
        if(irotsl.eq.1) then
          write(istdpr,140) nm,l,m,nord,frq
        else
          write(istdpr,145) nm,l,nord,frq
        end if
      end if
c
      go to 10
c
   90 continue
      stop
c
  130 format(' File name: ',a//' n, l, m, order, frequency (microHz)'/)
  135 format(' File name: ',a//' n, l, order, frequency (microHz)'/)
  140 format(4i6,f10.3)
  145 format(3i6,f10.3)
      end
