      subroutine rsnfit(x,nibc,nn,nev1,nfit,xfit1,xfitst,nftcnt,nftrcs,
     *  call_routine)
c
c  resets fitting point, depending on nftcrs:
c  nftcrs = 0: reset based on meshpoint number
c  nftrcs = 1: reset based on mesh in x
c  reset alternates between decreasing and increasing and decreasing,
c  depending on nftcnt
c
c  Modified 1/6/19, allowing for large numbers of resets.
c  Ensure that fitting point is outside evanescent region.
c
c  Modified 7/6/21, correcting reset if x_fit < x_ev.
c
c  original version: 30/4/02
c
      implicit double precision(a-h, o-z)
      character*(*) call_routine
      include 'adipls.c.d.incl'
      dimension x(nnmax)
      common/cincnt/ xmnevn,xfit, fcnorm, eps, epssol, dsigmx, fsig, 
     *  dsigre,icow,iturpr,iplneq,iriche,nnwwin, moddet, itmax, irsevn, 
     *  nftmax,irsord,iekinr,itsord,imissl,imjssl,imstsl
c
c  common defining standard input and output
c
      common/cstdio/ istdin, istdou, istdpr, istder
c
      if(istdpr.gt.0) write(istdpr,'(/'' Enter rsnfit from '',a)')
     *  call_routine
c
      nftcnt=nftcnt+1
c
c  test for mode of change
c
c to allow for large nftcnt, set scale of change
c
      nftscl=1+mod(nftcnt,9)
c
      nfitst=nfit
c
      if(nftrcs.eq.0) then 
        if(mod(nftscl,2).eq.1) then
          nfit=max(10,nint(nfit-0.025*nftscl*nn))
        else
          nfit=min(nint(nfit+0.025*nftscl*nn),nn-10)
        endif
c
      else
c  
c  base change on mesh in x
c
        dx=0.025d0*min(xfit1,1.d0-xfit1)
        if(mod(nftscl,2).eq.1) then
          xfit1=xfit1-nftscl*dx
          if(xfit1.le.x(nev1)) then
            if(istdpr.gt.0) write(istdpr,'(/'' In s/r rsnfit '',
     *        '' xfit = '',1pe13.5,'' < x(nev1) = '',e13.5/
     *        '' Move xfit outwards instead'')') xfit1, x(nev1) 
            xfit1=xfit1+2*nftscl*dx
            nftcnt=nftcnt+1
          end if
        else
          xfit1=xfit1+nftscl*dx
        end if
c
        do 20 n=1,nn
        nfit=n
        if(x(n).gt.xfit1) go to 25
   20   continue
c
c  limit range of nfit
c
   25   nfit=min(nn-10,max(10,nfit))
c
      end if
c
c  test for resetting nfit 
c
      if(mod(nfit-nibc,2).ne.0) then
        nfit=nfit+1
      end if
      xfit1=x(nfit)
      if(istdou.ne.istdpr.and.istdpr.gt.0) write(istdpr,'(
c..     *  '' Problems with scan or convergence''/
     *  '' Changing (nfit, xfit) from'',i6,f10.5, '' to'',i6,f10.5)')
     *  nfitst, xfitst, nfit, xfit1
      if(istdpr.gt.0) write(istdpr,'('' Exit rsnfit'')')
      return
      end
