#!/bin/csh
#  driver for adipls.c.d.x Usage:
#  run-adipls.c  <input> <output>
#  uses the file <input> as input (assumed to be in current directory,
#  if complete path is not given)
#  produces output file on <output>, 
#  or on ttt/<output>
#  if complete path is not given


if($#argv == 0) then
  echo "Usage:"
  echo "run-adipls.c  <input> [output]"
  echo "If output file is not specified, output goes to standard output"
  exit(1)
endif

set prog = adipls.c.d.x

set ain = $1
if($#argv > 1) then
  set aout = $2
endif

set dirin=`test-dir $ain`
if ($dirin == "n") then
	set in = $cwd/$ain
else
	set in = $in
endif

if($?aout) then
  set dirout=`test-dir $aout`
  if ($dirout == "n") then
        if(-d ttt) then
        else
          mkdir ttt
          echo "Making ttt"
        endif
	set out = ttt/$aout
  else
	set out = $aout
  endif
endif

if($?out) then
  get-input $in | $aprgdir/adipls/$prog > $out
else
  get-input $in | $aprgdir/adipls/$prog 
endif

