pro read_sphkers,lun,x,kers,n,css,file=kfile,double=kdouble,diag=kdiag, $
   swap=swap

;  reads binary kernels for spherical rotation from file.
;  if file is set, opens file and reads first kernel
;  if the unit number is et in lun, this is used,
;  otherwise lun is set to 1.

;  if file is not set, read is from unit lun, which is assumed
;  to be open

;  if double is set, the data are in double precision,
;  otherwise in single precision
;  If swap is set, use swap_endian, for reading, e.g., linux files
;  from bigcat


if keyword_set(kfile) then begin
	if keyword_set(lun) eq 0 then lun=1
	if keyword_set(swap) then swap = 1 else swap = 0
	openr,lun,kfile,/f77_unformatted,swap_endian=swap
endif

if EOF(lun) then begin
	print,' ****** EOF on unit',lun,'^G'
	n=-1
	return
endif

n=1l
if keyword_set(kdouble) then cs=dblarr(50) else cs=fltarr(50)

point_lun,-lun,pos

readu,lun,cs,n

if keyword_set(kdouble) then a=dblarr(2,n) else a=fltarr(2,n)

nrdmax=99
kers=dblarr(n,100)
css=dblarr(50,100)

point_lun,lun,pos
readu,lun,cs,n,a
x=a(0,*)
kers(*,0)=a(1,*)
css(*,0)=cs
if keyword_set(kdiag) then $
  print,' In read_sphker l, n, freq  =', cs(17),cs(18),cs(26)

nread=1
while (NOT EOF(lun) and nread lt nrdmax) do begin
  readu,lun,cs,n,a
  kers(*,nread)=a(1,*)
  css(*,nread)=cs
  if keyword_set(kdiag) then $
    print,' In read_sphker l, n, freq  =', cs(17),cs(18),cs(26)
  nread=nread+1
endwhile

nread=nread-1
kers=kers(*,0:nread)
css=css(*,0:nread)
return
end
